import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import greenfoot.junitUtils.jupiter.runner.GreenfootRunner;
import greenfoot.junitUtils.*;

@ExtendWith(GreenfootRunner.class)
class MyWorldTest {
    
    MyWorld world;
    Ball ball;
    
    @BeforeEach
    void setUp() throws Exception {
        // GIVEN: The local variables are a world and its actor
        world = new MyWorld();
        ball = world.getObjects(Ball.class).get(0);
    }
    
    @Test
    void testConstructor() throws Exception {
        // GIVEN: The local variable belongs to MyWorld class 
        MyWorld world;

        // WHEN : The action to test is the MyWorld constructor
        world = new MyWorld();
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals(1, world.getObjects(Ball.class).size());
        assertEquals(2, world.getObjects(Ball.class).get(0).getX());
        assertEquals(1, world.getObjects(Ball.class).get(0).getY());
    }

    @Test
    void testImage() throws Exception {
        // GIVEN: The local variable belongs to MyWorld class 
        greenfoot.GreenfootImage image = world.getBackground();

        // WHEN : The action to test is the MyWorld constructor
        String name = image.getImageFileName();
        
        // THEN : The asserts to verify are the number, in this case
        //        one, and position of the single Ball object.
        assertEquals("bluerock.jpg", name);
    }
    
    @Test
    void testOtherWorld() throws Exception {
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        WorldCreator.runOnce(world);
               
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
    @Test
    void testOtherWorldBis() throws Exception {        
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        world.act();
               
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
    @Test
    void testOtherWorldBisBis() throws Exception {        
        // WHEN : The action to test is the key pressed
        EventDispatch.keyPressed("n");
        WorldCreator.runOnce();       
        
        // THEN : The asserts to verify is that the ball is in new world
        assertEquals(OtherWorld.class, ball.getWorld().getClass());
    }
    
}
